# Lesser Open Credit License (LOCL) 1.0

## 1. Definitions

- **A. "Software"** refers to the original work licensed under this agreement, including source code, compiled binaries, documentation, and any associated media.  
- **B. "Original Author"** refers to the entity or person(s) who hold copyright over the Software.  
- **C. "Derivative Work"** refers to any modification, adaptation, extension, translation, or other transformation of the Software.  
- **D. "Redistribution"** refers to any act of sharing, selling, publishing, sublicensing, or otherwise distributing the Software or Derivative Work.  
- **E. "User-Facing Product"** refers to any software, service, or application that directly interacts with end users and incorporates this Software.  

## 2. Rights and Permissions

- **A.** You are granted a perpetual, worldwide, royalty-free, non-exclusive license to use, copy, modify, and distribute this Software for any purpose, including commercial and non-commercial applications, provided that credit is given to the Original Author as outlined in Section 3.  
- **B.** You may create and distribute Derivative Works of this Software, provided that proper credit is given to the Original Author as outlined in Section 3 and that the Derivative Work remains under this license or any other Open Source Initiative (OSI)-approved license.  
- **C.** This license does not restrict the use of the Software in proprietary projects, and modifications to the Software may remain private if not distributed.  
- **D.** Any distribution, including within a larger project, must retain the Open Credit License (LOCL) 1.0 for the portions of code originally under this license unless relicensed under an OSI-approved license. Users are not required to make the entire project subject to LOCL 1.0 if combining it with other OSI-approved licenses.  
- **E.** Any use of the Software, whether in part or in whole, must reference this license in the codebase. This may be achieved by including a copy of the license in a primary location (such as the root directory) and specifying which files or folders contain the licensed content.  
- **F.** Under no circumstances may this license be fully removed from any part of the Software that originally included it. The license text must remain intact in all copies, distributions, and derivative versions of the Software.  

## 3. Credit and Attribution Requirements

- **A.** Any distribution of the Software, including modified or combined versions, should include an acknowledgment of the Original Author and prior contributors in the source code or documentation where practical.  
- **B.** If the Software is used in a User-Facing Product, the Original Author should be credited in an "About," "Credits," or similar section when feasible but not in a way that restricts use or distribution. For commercial products, attribution can be placed in accessible documentation or websites, and it is not required to appear directly in the product interface unless branding is impacted.  
- **C.** The Original Author's name, pseudonym, or project name should not be removed from any copyright notice within the Software unless explicitly permitted.  
- **D.** If significant modifications are made, the modifying party is encouraged to document the changes and include a notice indicating modifications were made.  
- **E.** Any public or commercial use of the Software should, where reasonable, include a notice stating that the Software includes components licensed under the Open Credit License (LOCL) 1.0.
- **F.** Any forks or derivative works must pass down the credit attribution responsibility to further downstream projects, ensuring that subsequent modifications and distributions also provide proper credit to the Original Author and prior contributors.  

## 4. Compatibility with Other Licenses

- **A.** The Software may be combined with or used within projects licensed under other open-source licenses, including GPL 3.0, Apache 2.0, MIT, and BSD. Redistribution under these other licenses is permitted, provided the attribution requirements of LOCL 1.0 are maintained.  
- **B.** Any Derivative Work released under a different OSI-approved license must still provide credit in accordance with Section 3 of this license.  
- **C.** When redistributing Software alongside works under GPL 3.0, Apache 2.0, MIT, or BSD licenses, the LOCL 1.0 terms must be explicitly referenced in the licensing documentation.  

## 5. Patent Protection

- **A.** By contributing to this Software, you grant a perpetual, worldwide, royalty-free, non-exclusive license to use, modify, and distribute any patents that you own or control that are necessary to use, modify, or distribute the Software.  
- **B.** If you initiate patent litigation claiming that the Software infringes a patent, your rights under this license are terminated with respect to the affected Software.  
- **C.** This patent grant is provided to all users, including those who modify or distribute the Software.  

## 6. No Warranty and Liability Disclaimer

- **A.** This Software is provided "as is," without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness for a particular purpose, and non-infringement.  
- **B.** In no event shall the Original Author be liable for any claim, damages, or other liability, whether in an action of contract, tort, or otherwise, arising from, out of, or in connection with the Software or the use or other dealings in the Software.  

## 7. Termination and Compliance

- **A.** If any provision of this license is violated, the rights granted under this license are immediately revoked for the violating party.  
- **B.** Compliance with this license may be restored at the discretion of the Original Author upon adequate remediation of the violation.  
- **C.** Any attempt to remove or falsify credit to the Original Author constitutes a material breach of this license.  
- **D.** Any attempt to remove this license from the Software or any of its derivative works, except as permitted under Section 4, constitutes a material breach of this license and results in the immediate revocation of granted rights.  

## 8. License Versioning and Modifications

- **A.** Future versions of this license may be published to refine or clarify its terms. The Original Author retains the right to release updated versions of the Open Credit License.  
- **B.** Users may choose to continue using the terms of this version (LOCL 1.0) or adopt a future version, as long as the Original Author's credit remains intact.  

## 9. Acceptance and Use

- **A.** By using, modifying, or distributing this Software, you agree to the terms of the Open Credit License (LOCL) 1.0.  
- **B.** Any use of the Software that does not comply with this license is prohibited.  
